using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using System.Web.UI.WebControls;
using System.Web.UI;

namespace Ruinet.Controls
{
  [DefaultProperty("Menu")]
  [ToolboxData("<{0}:MenuComposite runat=server></{0}:MenuComposite>")]
  public class MenuComposite : WebControl
  {
    /// <summary>
    /// ûȡѡĲ˵
    /// </summary>
    [Bindable(true)]
    [DefaultValue("")]
    [Localizable(true)]
    public string SelectedMenuText
    {
      get
      {
        String s = (String)ViewState["SelectedMenuText"];
        return ((s == null) ? String.Empty : s);
      }

      set
      {
        ViewState["SelectedMenuText"] = value;
      }
    }

    /// <summary>
    /// ȡò˵ViewState
    /// </summary>
    [Bindable(true)]
    [DefaultValue(null)]
    [Localizable(true)]
    public MenuCompositeItem MenuItems
    {
      get
      {
        return ViewState["MenuItems"] as MenuCompositeItem;
      }

      set
      {
        ViewState["MenuItems"] = value;
      }
    }

    /// <summary>
    /// ֲ˵ṹ
    /// </summary>
    /// <param name="output">HTML</param>
    protected override void RenderContents(HtmlTextWriter output)
    {
      MenuCompositeItem root = this.MenuItems;

      output.Write(@"<div class=""navmenu"">");
      output.Write(@"	<ul>");

      for (int i = 0; i < root.Children.Count; i++)
      {
        RecursiveRender(output, root.Children[i]);
      }
      output.Write(@"	</ul>");
      output.Write(@"</div>");
    }

    /// <summary>
    /// ݹ˵
    /// </summary>
    /// <param name="output">HTML</param>
    /// <param name="item">˵.</param>
    /// <param name="depth">Indentation depth.</param>
    private void RecursiveRender(HtmlTextWriter output, MenuCompositeItem item)
    {
      output.Write("<li>");
      if (string.IsNullOrEmpty(item.Target))//ΪղתĿ
      {
        output.Write(@"<a href=""" + item.Link + @""">");
      }
      else
      {
        output.Write(@"<a href=""" + item.Link + @""" target= """ + item.Target + @""">");
      }
      if (item.Text == SelectedMenuText)  //ѡеĲ˵
      {
        output.Write(@"<span class=""selected"">");
        output.WriteLine(item.Text);
        output.WriteLine("</span>");
      }
      else
      {
        output.Write(item.Text);
      }

      output.Write("</a>");

      if (item.Children.Count > 0)
      {
        output.WriteLine();
        output.Write("<ul>");
        for (int i = 0; i < item.Children.Count; i++)
        {
          RecursiveRender(output, item.Children[i]);
        }
        output.Write("</ul>");
      }
      output.Write("</li>");
    }
  }
}
